package com.jkcredit.invoice.service.nocar.impl;

import cn.com.taiji.sdk.model.comm.protocol.tts.card.server.CardBindQueryListToBModel;
import cn.com.taiji.sdk.model.comm.protocol.tts.card.server.CardBindQueryListToBRequest;
import cn.com.taiji.sdk.model.comm.protocol.tts.card.server.CardBindQueryListToBResponse;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.jkcredit.invoice.mapper.customer.CustomerCarRecMapper;
import com.jkcredit.invoice.model.entity.customer.CustomerCarRec;
import com.jkcredit.invoice.service.nocar.NoCarRecService;
import com.jkcredit.invoice.service.upService.SelfCarInterface;
import com.jkcredit.invoice.util.RespR;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.util.StringUtils;

import java.util.List;
@Service
public class NoCarRecServiceImpl extends ServiceImpl<CustomerCarRecMapper,CustomerCarRec> implements NoCarRecService {
    @Autowired
    CustomerCarRecMapper customerCarRecMapper;
    @Autowired
    SelfCarInterface selfCarInterface;
    @Override
    public IPage<List<CustomerCarRec>> findByPageAndCarRec(Page page, CustomerCarRec customerCarRec) {
        if("0".equals(customerCarRec.getBusinessType()) && !StringUtils.isEmpty(customerCarRec.getCarNum())){
            //
            List<CustomerCarRec> customerCarRecs = customerCarRecMapper.selectBySelfCarNum(customerCarRec.getCarNum());
            if(customerCarRecs!=null && customerCarRecs.size()>0){
                CardBindQueryListToBRequest cardBindQueryListToBRequest = new CardBindQueryListToBRequest();
                cardBindQueryListToBRequest.setPlateNum(customerCarRecs.get(0).getCarNum());
                cardBindQueryListToBRequest.setCompanyNum(customerCarRecs.get(0).getCompanyNum());
                RespR<CardBindQueryListToBResponse> responseRespR = selfCarInterface.cardBindQueryListToB(cardBindQueryListToBRequest);
                if(responseRespR.getCode() !=1){
                    List<CardBindQueryListToBModel> cardBindQueryListToBResponses = responseRespR.getData().getResult();
                    if(cardBindQueryListToBResponses!=null && cardBindQueryListToBResponses.size()>0){
                        customerCarRecs.forEach(customerCarRec1 -> {
                            boolean has = false;
                            for(CardBindQueryListToBModel cardBindQueryListToBModel:cardBindQueryListToBResponses){
                                if(cardBindQueryListToBModel.getCardId().equals(customerCarRec1.getEtcNum())){
                                    has = true;
                                }
                            }
                            if(!has){
                                customerCarRec1.setRecStatus(2);
                                customerCarRecMapper.updateETCByPrimaryKeySelective(customerCarRec1);
                            }
                        });
                    }

                }
            }


        }
        return customerCarRecMapper.selectAllByPage(page,customerCarRec);
    }
}
